Subject: Re: Add *

From: Nancy-M Greene <[email-masked]>
Date: Wed, 1 Sep 1999 22:15:01 -0400

So, putting Add * command in an action is a short form for the action
request, but there is no short form for the response to that request - for
each add the MG performed, you would get back an Add response.

If we carry this reasoning over to Subtract *, then a request containing
Subtract * would return a list of Subtract responses, one for each subtract
that occurred. (This means the current ABNF for Subtract response that
provides for a list of termination Ids being returned, is unnecessary...
instead you would get a series of Subtracts each with a terminationId as a
response parameter - or do we leave the list there for efficiency?)

As for whether the Add * (or Subtract * or Modify *) should stop as soon as
one Add (or Subtract or Modify) fails - I think not. Terminations are not
ordered, so we do not need to assume the * implies any ordering. I think
Add/Subtract/Modify * should be executed as "best effort" - they should
apply to all terminations matching the wildcard. So you get back either all
successes, or a mixture of successes and failures.

Nancy
--------------------------------------------------------------------------
Nancy M. Greene
Internet & Service Provider Networks, Nortel Networks
T:514-271-7221 (internal:ESN853-1077) E:[email-masked]

> ----------
> From:         Brian Rosen[SMTP:[email-masked]]
> Sent:         Wednesday, September 01, 1999 2:13 PM
> To:   Greene, Nancy-M [CAR:5N10:EXCH]; [email-masked]
> Subject:      RE: Add *
>
> Not quite, but close.
>
> The Reject tells you the terminationID of the ones that succeeded before
> the
> failed one, and it tells you the failed one.  It does not tell you any
> others than might not have been attempted.
>
> So, using my example, if MyTerm2 failed, you get
> Reject{ Add=MyTerm1{...}, Add=MyTerm2{202: Some kind of error}
>
> So the text might be:
> "If an Add with a wildcarded termination is used, the
> command fails if one or more terminations failed to be
> added to the specified context. All terminations
> prior to the failed termination will be in the context,
> the termination that encountered the error and all succeeding
> terminations will not be in the context.  The MGC may issue
> an AuditValue with the given context to find out exactly
> which terminations now exist in the context."
>
> We could redefine it so that it always attempts every matched termination,
> and gives you success or failure for each possible one.
>
Yes, the MG should always attempt every matched termination - terminations
are not ordered.

> Could I point out a minor problem using my example?
>
> We probably want to change the error syntax to:
> Add=MyTerm2{Error=202{"Some kind of error"}}
>
> This makes error a descriptor with similar syntax to all other
> descriptors,
> and allows parsers to treat operands of all commands to be descriptors.
>
> Brian
>
>
> > -----Original Message-----
> > From: Nancy-M Greene [mailto:[email-masked]]
> > Sent: Wednesday, September 01, 1999 12:53 PM
> > To: [email-masked]
> > Subject: Re: Add *
> >
> >
> > Ok, let's be clear on what happens then. As many adds as are
> > matched by the
> > * are attempted. Some fail, some succeed. If one or more
> > fails, the Add
> > returns a failed return code, and the MGC needs to issue an
> > AuditValue with
> > terminationId=*, or with context=contextId given in the Add,
> > to actually
> > find out what happened. The ones that succeeded are not
> > rolled back in any
> > case.
> >
> > Note that this discussion applies to Subtract *, and Modify * as well.
> >
> > So text something like the following needs to be added to the
> > descriptions
> > for Add, Subtract and Modify:
> >
> > If an Add with a wildcarded termination is used, the command
> > fails if one or
> > more terminations failed to be added to the specified
> > context. The MGC may
> > issue an AuditValue with the given context to find out exactly which
> > terminations now exist in the context.
> >
> > Nancy
> > --------------------------------------------------------------
> > ------------
> > Nancy M. Greene
> > Internet & Service Provider Networks, Nortel Networks
> > T:514-271-7221 (internal:ESN853-1077) E:[email-masked]
> >
> > > ----------
> > > From:         Brian Rosen[SMTP:[email-masked]]
> > > Sent:         Wednesday, September 01, 1999 7:57 AM
> > > To:   [email-masked]
> > > Subject:      Re: Add *
> > >
> > > I agree with Tom's analysis.  If MyTerm* matches
> > > MyTerm1, MyTerm2 and MyTerm3, and I do Add=MyTerm*{...,
> > > then unless all three Terminations are added, the command fails.
> > >
> > > Bria
> > >
> > >
> >
>